// OB6
// 21-8-2013
//
// Taper Barre d'espace pour ecouter
//
// Voir:
// http://www.sojamo.de/libraries/controlP5/examples/use/ControlP5controlFont/ControlP5controlFont.pde
//

/*
 * ControlP5 ListBox
 * find a list of public methods available for the ListBox Controller
 * at the bottom of this sketch.
 * use the scrollwheel, up or down cursors to scroll through 
 * a listbox when hovering with the mouse.
 * by Andreas Schlegel, 2012
 * www.sojamo.de/libraries/controlp5
 */


import controlP5.*; // Menu deroulant
import ddf.minim.*;

ControlP5 Mot1, Mot2, Mot3;
ListBox list1, list2, list3;

Minim minim;
AudioPlayer[] player = new AudioPlayer[20];

int cnt = 0;
int count = 3;
int HauteurPoeme = 100;
int HauteurLigne = 30;
int XPoeme = 530;
boolean Ecoute = false;

color[] Couleurs = { 
  color(50, 50, 50), color(56, 0, 255), color(56, 0, 255), 
  color(101, 252, 139), color(101, 252, 139), color(255, 187, 0), 
  color(255, 187, 0), color(255, 212, 205), color(255, 212, 205), 
  color(254, 255, 189), color(254, 255, 189), color(254, 24, 0), 
  color(254, 24, 0), color(164, 0, 245), color(164, 0, 245), 
  color(102, 232, 254), color(102, 232, 254), color(0, 205, 52), 
  color(0, 205, 52), color(250, 251, 0), color(250, 251, 0), 
  color(100, 100, 100)
};

void setup() {
  size(1024, 768);
  minim = new Minim(this);

  // background(0);

  PFont pfont = createFont("Arial", 20, true); // use true/false for smooth/no-smooth
  ControlFont font = new ControlFont(pfont, 241);


  // ControlP5.printPublicMethodsFor(ListBox.class);

  Mot1 = new ControlP5(this);
  list1 = Mot1.addListBox("Mot1")
    .setPosition(XPoeme, HauteurPoeme)
      //   .setSize(168, 264)
      .setSize(168, 60) // Diminuer 264 pour faire apparaitre la scrollbar 
        .setItemHeight(12)
          .setBarHeight(HauteurLigne)
            .setColorBackground(Couleurs[0])
              .setColorActive(color(0))
                .setColorForeground(Couleurs[21])
                  .setScrollbarWidth(20)
                    .enableCollapse()
                      ;
  list1.captionLabel().toUpperCase(false);
  list1.captionLabel().set("Mon Oiseau bleu");
  list1.captionLabel().setColor(0);
  list1.captionLabel().style().marginLeft = 4;
  list1.captionLabel().style().marginTop = 2;
  list1.valueLabel().style().marginTop = 0;
  list1.captionLabel()
    .setFont(font)
      .setSize(20)
        .toUpperCase(false)
          ;
  CreationMenu("Mon Oiseau bleu", list1);
  list1.actAsPulldownMenu(true);


  Mot2 = new ControlP5(this);
  list2 = Mot1.addListBox("Mot2")
    .setPosition(XPoeme + 168, HauteurPoeme + HauteurLigne)
      .setSize(110, 264)
        .setItemHeight(12)
          .setBarHeight(HauteurLigne)
            .setColorBackground(Couleurs[0])
              .setColorActive(color(0))
                .setColorForeground(Couleurs[21])
                  .enableCollapse();
  list2.captionLabel().toUpperCase(false);
  list2.captionLabel().set("a le ventre");
  list2.captionLabel().setColor(0);
  list2.captionLabel().style().marginLeft = 2;
  list2.captionLabel().style().marginTop = 2;
  list2.valueLabel().style().marginTop = 0;
  list2.captionLabel()
    .setFont(font)
      .setSize(20)
        .toUpperCase(false)
          ;
  CreationMenu("a le ventre", list2);
  list2.actAsPulldownMenu(true);


  Mot3 = new ControlP5(this);
  list3 = Mot1.addListBox("Mot3")
    .setPosition(XPoeme + 276, HauteurPoeme + 2 * HauteurLigne)
      .setSize(92, 264)
        .setItemHeight(12)
          .setBarHeight(HauteurLigne)
            .setColorBackground(Couleurs[0])
              .setColorActive(color(0))
                .setColorForeground(Couleurs[21])
                  .enableCollapse();
  list3.captionLabel().toUpperCase(false);
  list3.captionLabel().set("tout bleu");
  list3.captionLabel().setColor(0);
  list3.captionLabel().style().marginLeft = 2;
  list3.captionLabel().style().marginTop = 2;
  list3.valueLabel().style().marginTop = 0;
  list3.captionLabel()
    .setFont(font)
      .setSize(20)
        .toUpperCase(false)
          ;
  CreationMenu("tout bleu", list3);
  list3.actAsPulldownMenu(true);

  //  player[1].play();   // play the file
}

void keyPressed() {
  if (key=='0') {
    // will activate the listbox item with value 5
    // l.setValue(5);
  }
  if (key=='1') {
    // set the height of a listBox should always be a multiple of itemHeight
    // l.setHeight(210);
  } 
  else if (key=='2') {
    // set the height of a listBox should always be a multiple of itemHeight
    // l.setHeight(120);
  } 
  else if (key=='3') {
    // set the width of a listBox
    // l.setWidth(200);
  }
  else if (key=='i') {
    // set the height of a listBoxItem, should always be a fraction of the listBox
    // l.setItemHeight(30);
  } 
  else if (key=='u') {
    // set the height of a listBoxItem, should always be a fraction of the listBox
    // l.setItemHeight(10);
    // l.setBackgroundColor(color(100, 0, 0));
  } 
  else if (key=='a') {
    int n = (int)(random(100000));
    // l.addItem("item "+n, n);
  } 
  else if (key=='d') {
    // l.removeItem("item "+cnt);
    cnt++;
  } 
  else if (key=='c') {
    // l.clear();
  }
}

void CreationMenu(String Mot, ListBox MaList) {
  for (int i=1;i<21;i++) {
    //  ListBoxItem lbi = l.addItem(Mot +"   "+i, i);
    ListBoxItem lbi = MaList.addItem(Mot +" ", i);
    lbi.setColorBackground(Couleurs[i]);
    lbi.toUpperCase(false);
  }
}

void controlEvent(ControlEvent theEvent) {
  // ListBox is if type ControlGroup.
  // 1 controlEvent will be executed, where the event
  // originates from a ControlGroup. therefore
  // you need to check the Event with
  // if (theEvent.isGroup())
  // to avoid an error message from controlP5.

  if (theEvent.isGroup()) {
    // an event from a group e.g. scrollList
    println(theEvent.group().value()+" from "+theEvent.group());
  }

  if (theEvent.isGroup() && theEvent.name().equals("Mot1")) {
    int test = (int)theEvent.group().value();
    println("test "+test);

    //  l.captionLabel().setColorBackground(Couleurs[test]);
    list1.setColorBackground(Couleurs[test]);
    list1.clear();
    CreationMenu("Mon Oiseau bleu", list1);
    player[1] = minim.loadFile(char(64 + test) +"/mon_oiseau_bleu.wav");
    player[1].play(0);
  }
  if (theEvent.isGroup() && theEvent.name().equals("Mot2")) {
    int test = (int)theEvent.group().value();
    println("test "+test);

    //  l.captionLabel().setColorBackground(Couleurs[test]);
    list2.setColorBackground(Couleurs[test]);
    list2.clear();
    CreationMenu("a le ventre", list2);
    player[2] = minim.loadFile(char(64 + test) +"/a_le_ventre.wav");
    player[2].play(0);
  }
  if (theEvent.isGroup() && theEvent.name().equals("Mot3")) {
    int test = (int)theEvent.group().value();
    println("test "+test);

    //  l.captionLabel().setColorBackground(Couleurs[test]);
    list3.setColorBackground(Couleurs[test]);
    list3.clear();
    CreationMenu("tout bleu", list3);
    player[3] = minim.loadFile(char(64 + test) +"/tout_bleu.wav");
    player[3].play(0);
  }
}

void draw() {
  background(0);
  if (Ecoute) {
    if (!player[count].isPlaying()) {
      count++;
      if (count>3) count=1;
      player[count].play(0);
      //      println("count = " + count);
    }
  }
}

void keyReleased() {
  if (key == ' ') { // Barre d'espace
    println("    Barre d'espace");
    Ecoute = true;
  }
}

/*
a list of all methods available for the ListBox Controller
 use ControlP5.printPublicMethodsFor(ListBox.class);
 to print the following list into the console.
 
 You can find further details about class ListBox in the javadoc.
 
 Format:
 ClassName : returnType methodName(parameter type)
 
 
 controlP5.ControlGroup : ControlGroup activateEvent(boolean) 
 controlP5.ControlGroup : ControlGroup addListener(ControlListener) 
 controlP5.ControlGroup : ControlGroup hideBar() 
 controlP5.ControlGroup : ControlGroup removeListener(ControlListener) 
 controlP5.ControlGroup : ControlGroup setBackgroundColor(int) 
 controlP5.ControlGroup : ControlGroup setBackgroundHeight(int) 
 controlP5.ControlGroup : ControlGroup setBarHeight(int) 
 controlP5.ControlGroup : ControlGroup showBar() 
 controlP5.ControlGroup : ControllerGroup updateInternalEvents(PApplet) 
 controlP5.ControlGroup : String info() 
 controlP5.ControlGroup : String toString() 
 controlP5.ControlGroup : boolean isBarVisible() 
 controlP5.ControlGroup : int getBackgroundHeight() 
 controlP5.ControlGroup : int getBarHeight() 
 controlP5.ControlGroup : int listenerSize() 
 controlP5.ControllerGroup : CColor getColor() 
 controlP5.ControllerGroup : ControlWindow getWindow() 
 controlP5.ControllerGroup : ControlWindowCanvas addCanvas(ControlWindowCanvas) 
 controlP5.ControllerGroup : Controller getController(String) 
 controlP5.ControllerGroup : ControllerGroup add(ControllerInterface) 
 controlP5.ControllerGroup : ControllerGroup close() 
 controlP5.ControllerGroup : ControllerGroup disableCollapse() 
 controlP5.ControllerGroup : ControllerGroup enableCollapse() 
 controlP5.ControllerGroup : ControllerGroup hide() 
 controlP5.ControllerGroup : ControllerGroup moveTo(ControlWindow) 
 controlP5.ControllerGroup : ControllerGroup open() 
 controlP5.ControllerGroup : ControllerGroup registerProperty(String) 
 controlP5.ControllerGroup : ControllerGroup registerProperty(String, String) 
 controlP5.ControllerGroup : ControllerGroup remove(CDrawable) 
 controlP5.ControllerGroup : ControllerGroup remove(ControllerInterface) 
 controlP5.ControllerGroup : ControllerGroup removeCanvas(ControlWindowCanvas) 
 controlP5.ControllerGroup : ControllerGroup removeProperty(String) 
 controlP5.ControllerGroup : ControllerGroup removeProperty(String, String) 
 controlP5.ControllerGroup : ControllerGroup setAddress(String) 
 controlP5.ControllerGroup : ControllerGroup setArrayValue(float[]) 
 controlP5.ControllerGroup : ControllerGroup setColor(CColor) 
 controlP5.ControllerGroup : ControllerGroup setColorActive(int) 
 controlP5.ControllerGroup : ControllerGroup setColorBackground(int) 
 controlP5.ControllerGroup : ControllerGroup setColorForeground(int) 
 controlP5.ControllerGroup : ControllerGroup setColorLabel(int) 
 controlP5.ControllerGroup : ControllerGroup setColorValue(int) 
 controlP5.ControllerGroup : ControllerGroup setHeight(int) 
 controlP5.ControllerGroup : ControllerGroup setId(int) 
 controlP5.ControllerGroup : ControllerGroup setLabel(String) 
 controlP5.ControllerGroup : ControllerGroup setMoveable(boolean) 
 controlP5.ControllerGroup : ControllerGroup setOpen(boolean) 
 controlP5.ControllerGroup : ControllerGroup setPosition(PVector) 
 controlP5.ControllerGroup : ControllerGroup setPosition(float, float) 
 controlP5.ControllerGroup : ControllerGroup setStringValue(String) 
 controlP5.ControllerGroup : ControllerGroup setUpdate(boolean) 
 controlP5.ControllerGroup : ControllerGroup setValue(float) 
 controlP5.ControllerGroup : ControllerGroup setVisible(boolean) 
 controlP5.ControllerGroup : ControllerGroup setWidth(int) 
 controlP5.ControllerGroup : ControllerGroup show() 
 controlP5.ControllerGroup : ControllerGroup update() 
 controlP5.ControllerGroup : ControllerGroup updateAbsolutePosition() 
 controlP5.ControllerGroup : ControllerProperty getProperty(String) 
 controlP5.ControllerGroup : ControllerProperty getProperty(String, String) 
 controlP5.ControllerGroup : Label captionLabel() 
 controlP5.ControllerGroup : Label valueLabel() 
 controlP5.ControllerGroup : PVector getPosition() 
 controlP5.ControllerGroup : String getAddress() 
 controlP5.ControllerGroup : String getName() 
 controlP5.ControllerGroup : String getStringValue() 
 controlP5.ControllerGroup : String info() 
 controlP5.ControllerGroup : String toString() 
 controlP5.ControllerGroup : Tab getTab() 
 controlP5.ControllerGroup : boolean isCollapse() 
 controlP5.ControllerGroup : boolean isMouseOver() 
 controlP5.ControllerGroup : boolean isMoveable() 
 controlP5.ControllerGroup : boolean isOpen() 
 controlP5.ControllerGroup : boolean isUpdate() 
 controlP5.ControllerGroup : boolean isVisible() 
 controlP5.ControllerGroup : boolean setMousePressed(boolean) 
 controlP5.ControllerGroup : float getValue() 
 controlP5.ControllerGroup : float[] getArrayValue() 
 controlP5.ControllerGroup : int getHeight() 
 controlP5.ControllerGroup : int getId() 
 controlP5.ControllerGroup : int getWidth() 
 controlP5.ControllerGroup : void remove() 
 controlP5.ListBox : ListBox actAsPulldownMenu(boolean) 
 controlP5.ListBox : ListBox addItems(List) 
 controlP5.ListBox : ListBox addItems(List, int) 
 controlP5.ListBox : ListBox addItems(String[]) 
 controlP5.ListBox : ListBox clear() 
 controlP5.ListBox : ListBox hideScrollbar() 
 controlP5.ListBox : ListBox removeItem(String) 
 controlP5.ListBox : ListBox scroll(float) 
 controlP5.ListBox : ListBox setColorActive(int) 
 controlP5.ListBox : ListBox setColorBackground(int) 
 controlP5.ListBox : ListBox setColorForeground(int) 
 controlP5.ListBox : ListBox setColorLabel(int) 
 controlP5.ListBox : ListBox setHeight(int) 
 controlP5.ListBox : ListBox setItemHeight(int) 
 controlP5.ListBox : ListBox setListBoxItems(String[][]) 
 controlP5.ListBox : ListBox setWidth(int) 
 controlP5.ListBox : ListBox showScrollbar() 
 controlP5.ListBox : ListBox toUpperCase(boolean) 
 controlP5.ListBox : ListBoxItem addItem(String, int) 
 controlP5.ListBox : ListBoxItem getItem(Controller) 
 controlP5.ListBox : ListBoxItem getItem(String) 
 controlP5.ListBox : ListBoxItem getItem(int) 
 controlP5.ListBox : String[][] getListBoxItems() 
 controlP5.ListBox : boolean isScrollbarVisible() 
 java.lang.Object : String toString() 
 java.lang.Object : String toString() 
 java.lang.Object : boolean equals(Object) 
 
 
 */
